package com.quantumblade.sampletax;

import com.quantumblade.cashcreeper.CashCreeper;
import com.quantumblade.cashcreeper.TransactionEvent;
import com.quantumblade.cashcreeper.TransactionLineItem;
import com.quantumblade.cashcreeper.TransactionResponse;

import net.minecraft.server.MinecraftServer;
import cpw.mods.fml.common.event.FMLInitializationEvent;

/**
 * 
 * @author Quantum Blade
 * http://creativecommons.org/licenses/by/4.0/
 * Cash Creeper Sample Tax by Quantum Blade is licensed under a Creative Commons Attribution 4.0 International License
 * http://www.quantumblade.com/minecraft/mods/CashCreeper/
 * http://www.minecraftforge.net/forum/index.php/topic,12378.0.html
 * http://www.minecraftforum.net/topic/1977870-152forgeeconomywip-cashcreeper-mod/
 *
 */
public class SampleTaxCommonProxy implements com.quantumblade.cashcreeper.TransactionListenerInterface {

	private CashCreeper CC = CashCreeper.instance;
	
	
	public void init(FMLInitializationEvent event) {
		if(CC == null) {
			MinecraftServer.getServer().logSevere("Cash Creeper Instance was null!!!");
		}
		else {
			System.err.println("About to register transaction listener with Cash Creeper");
			CC.addTransactionListener(this);
		}
		
	}

	@Override
	public TransactionResponse notifyTransaction(TransactionEvent e) {
		String fromAccount = e.getFromAccountName();
		int amount = e.getFromAmount();
		int tax = Math.round(amount * 0.08f);

		if(CC.accountHasAmount(fromAccount, amount + tax)) {
			TransactionLineItem line = new TransactionLineItem("Sales Tax", tax);
			e.addFromLineItem(line);
			
			return new TransactionResponse(true, "");
    	}
		
		return new TransactionResponse(false, "Insuffecient funds to cover sales tax!");
		
	}
}
